## openturns 1.2

=== CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

cmake_minimum_required ( VERSION 2.8 )

option ( USE_BISON                    "Looks for Bison if true and then build parser"                         ON )
option ( USE_FLEX                     "Looks for Flex if true and then build lexer"                           ON )
option ( USE_TBB                      "Use Intel Threading Building Blocks library for multithreading"        ON )
option ( USE_INTERNAL_BLASLAPACK      "Force usage of internal BLAS/LAPACK libraries"                         OFF )
option ( USE_INTERNAL_MUPARSER        "Force usage of internal muParser libraries"                            ON )
option ( USE_LIBXML2                  "Use LibXml2 for XML support"                                           ON )
option ( USE_R                        "Use R for graph output support"                                        ON )
option ( SYSTEM_INSTALL               "True if Open TURNS is installed in a system directory. RPATH removed." OFF )
option ( BUILD_LIB                    "Build the library"                                                     ON )
option ( BUILD_PYTHON                 "Build the python module for the library"                               ON )
option ( BUILD_VALIDATION             "Build the validation files of the library"                             ON )
option ( LINK_PYTHON_LIBRARY          "Link python modules against python library"                            ON )
option ( INSTALL_TESTS                "Install compiled tests for native platform testing"                    OFF )

# By default, build in Release mode. Must appear before project() command
if ( NOT DEFINED CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Build type" )
endif ()

project ( OpenTURNS CXX )

# Defines our own module path
list ( APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake )

if ( BUILD_LIB )

enable_language ( C Fortran )

if ( USE_BISON )
  find_package ( BISON )
  if ( BISON_FOUND )
    set ( HAVE_BISON TRUE )
  endif ()
endif ()

if ( USE_FLEX )
  find_package ( FLEX )
  if ( FLEX_FOUND )
    set ( HAVE_FLEX TRUE )
  endif ()
endif ()

if ( USE_TBB )
  find_package ( TBB )
endif ()

if ( NOT USE_INTERNAL_BLASLAPACK )
  find_package ( BLAS )
  find_package ( LAPACK )
endif ()

if ( NOT USE_INTERNAL_MUPARSER )
  find_package ( MuParser 1.32 REQUIRED )
endif ()

find_package ( Doxygen )

if ( USE_LIBXML2 )
  find_package ( LibXml2 )
endif ()

find_package ( Threads )
find_package ( Libdl )
find_package ( Regex )

if ( USE_R )
  find_package ( R COMPONENTS base rot )
endif ()

include ( TestBigEndian )
test_big_endian ( __BIG_ENDIAN__ ) 

# Find system prerequisites
include ( CheckIncludeFile )
check_include_file ( arpa/inet.h   HAVE_ARPA_INET_H   )
check_include_file ( assert.h      HAVE_ASSERT_H      )
check_include_file ( dirent.h      HAVE_DIRENT_H      )
check_include_file ( errno.h       HAVE_ERRNO_H       )
check_include_file ( inttypes.h    HAVE_INTTYPES_H    )
check_include_file ( malloc.h      HAVE_MALLOC_H      )
check_include_file ( math.h        HAVE_MATH_H        )
check_include_file ( netdb.h       HAVE_NETDB_H       )
check_include_file ( netinet/in.h  HAVE_NETINET_IN_H  )
check_include_file ( netinet/tcp.h HAVE_NETINET_TCP_H )
check_include_file ( pthread.h     HAVE_PTHREAD_H     )
check_include_file ( regex.h       HAVE_REGEX_H       )
check_include_file ( semaphore.h   HAVE_SEMAPHORE_H   )
check_include_file ( signal.h      HAVE_SIGNAL_H      )
check_include_file ( stdbool.h     HAVE_STDBOOL_H     )
check_include_file ( stdint.h      HAVE_STDINT_H      )
check_include_file ( stdlib.h      HAVE_STDLIB_H      )
check_include_file ( string.h      HAVE_STRING_H      )
check_include_file ( strings.h     HAVE_STRINGS_H     )
check_include_file ( sys/socket.h  HAVE_SYS_SOCKET_H  )
check_include_file ( sys/stat.h    HAVE_SYS_STAT_H    )
check_include_file ( sys/time.h    HAVE_SYS_TIME_H    )
check_include_file ( sys/types.h   HAVE_SYS_TYPES_H   )
check_include_file ( sys/un.h      HAVE_SYS_UN_H      )
check_include_file ( unistd.h      HAVE_UNISTD_H      )

else ()
  find_package ( OpenTURNS NO_MODULE REQUIRED )
endif ()

# Some useful macros to ease CMakeLists.txt file writing
set ( SOURCEFILES "" CACHE INTERNAL "List of source files to compile" )
macro ( ot_add_source_file FILENAME )
  set ( sf ${SOURCEFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME} )
  set ( SOURCEFILES ${sf} CACHE INTERNAL "List of source files to compile" )
endmacro ( ot_add_source_file )

set ( BUILT_SOURCEFILES "" CACHE INTERNAL "List of source files to compile" )
macro ( ot_add_built_source_file FILENAME )
  set ( sf ${BUILT_SOURCEFILES} ${FILENAME} )
  set ( BUILT_SOURCEFILES ${sf} CACHE INTERNAL "List of built source files to compile" )
endmacro ( ot_add_built_source_file )

set ( HEADERFILES "" CACHE INTERNAL "List of header files to install" )
macro ( ot_install_header_file FILENAME )
  set ( hf ${HEADERFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME} )
  set ( HEADERFILES ${hf} CACHE INTERNAL "List of header files to install" )
endmacro ( ot_install_header_file )

set ( SWIGFILES "" CACHE INTERNAL "List of SWIG files to install" )
macro ( ot_install_swig_file FILENAME )
  set ( hf ${SWIGFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME} )
  set ( SWIGFILES ${hf} CACHE INTERNAL "List of SWIG files to install" )
endmacro ( ot_install_swig_file )

set ( INTERNAL_INCLUDE_DIRS "" CACHE INTERNAL "List of directories with header files needed for build" )
macro ( ot_add_current_dir_to_include_dirs )
  set ( inc_dirs ${INTERNAL_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR} )
  set ( INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build" )
endmacro ( ot_add_current_dir_to_include_dirs )
macro ( ot_add_build_dir_to_include_dirs DIR )
  set ( inc_dirs ${INTERNAL_INCLUDE_DIRS} ${DIR} )
  set ( INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build" )
endmacro ( ot_add_build_dir_to_include_dirs )

if ( MINGW )
  set ( WIN32 1 )
  list ( APPEND OPENTURNS_LIBRARIES ws2_32 )
endif ()

if ( WIN32 )
  list ( APPEND OPENTURNS_DEFINITIONS -DWIN32 )
endif ()

# Add definitions according to the prerequisites found
add_definitions( -DHAVE_CONFIG_H )

# CMake makefiles don't link against stdc++ on OSX
if ( APPLE )
  list ( APPEND OPENTURNS_LIBRARIES stdc++ )
endif ()

if ( LIBXML2_FOUND )
  set ( HAVE_LIBXML2 TRUE )
  list ( APPEND OPENTURNS_DEFINITIONS ${LIBXML2_DEFINITIONS} )
  list ( APPEND OPENTURNS_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR} )
  list ( APPEND OPENTURNS_LIBRARIES ${LIBXML2_LIBRARIES} )
endif ()

if ( LAPACK_FOUND )
  list ( APPEND OPENTURNS_LIBRARIES ${LAPACK_LIBRARIES} )
endif ()

if ( MUPARSER_FOUND )
  list ( APPEND OPENTURNS_LIBRARIES ${MUPARSER_LIBRARIES} )
  list ( APPEND OPENTURNS_INCLUDE_DIRS ${MUPARSER_INCLUDE_DIRS} )
endif ()

if ( MINGW )
  list ( APPEND OPENTURNS_DEFINITIONS -mthreads )
  list ( APPEND OPENTURNS_LIBRARIES pthreadGC2 )
else ()
  if ( Threads_FOUND )
    list ( APPEND OPENTURNS_DEFINITIONS -pthread )
    list ( APPEND OPENTURNS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )
  endif ( Threads_FOUND )
endif ()

if ( TBB_FOUND )
  set ( HAVE_TBB TRUE )
  set ( HAVE_TBB_TBB_H TRUE )
  list ( APPEND OPENTURNS_INCLUDE_DIRS ${TBB_INCLUDE_DIRS} )
  list ( APPEND OPENTURNS_LIBRARIES ${TBB_LIBRARIES} )
endif ()

if ( LIBDL_FOUND )
  set ( HAVE_LIBDL TRUE )
  list ( APPEND OPENTURNS_INCLUDE_DIRS ${LIBDL_INCLUDE_DIR} )
  list ( APPEND OPENTURNS_LIBRARIES ${LIBDL_LIBRARIES} )
endif ()

if ( REGEX_FOUND )
  set ( HAVE_REGEX TRUE )
  list ( APPEND OPENTURNS_INCLUDE_DIRS ${REGEX_INCLUDE_DIR} )
  list ( APPEND OPENTURNS_LIBRARIES ${REGEX_LIBRARIES} )
endif ()

add_definitions ( ${OPENTURNS_DEFINITIONS} )
if ( OPENTURNS_INCLUDE_DIRS )
  list ( REMOVE_DUPLICATES OPENTURNS_INCLUDE_DIRS )
endif ( OPENTURNS_INCLUDE_DIRS )
include_directories ( ${OPENTURNS_INCLUDE_DIRS} )

set ( CPACK_PACKAGE_NAME          openturns      )
set ( CPACK_PACKAGE_VERSION_MAJOR 1              )
set ( CPACK_PACKAGE_VERSION_MINOR 2 )
set ( CPACK_PACKAGE_VERSION_PATCH                )
set ( CPACK_SOURCE_GENERATOR      "TGZ;TBZ2"     )
set ( CPACK_BINARY_STGZ           "OFF"          )
set ( CPACK_BINARY_TBZ2           "ON"           )
set ( CPACK_BINARY_TGZ            "ON"           )
set ( CPACK_BINARY_TZ             "OFF"          )
set ( CPACK_SOURCE_IGNORE_FILES "/.svn;/build;.*~;${CPACK_SOURCE_IGNORE_FILES}" )
#set ( CPACK_INSTALL_CMAKE_PROJECTS "lib;OpenTURNSLib;ALL;/" "python;OpenTURNSPython;ALL;/" )


# Set global definitions
# TODO: remove PACKAGE_<XX> from source code. Needed for compatibility with autotools
set ( PACKAGE_NAME           ${CPACK_PACKAGE_NAME} )
set ( PACKAGE_VERSION        ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR} )
if ( CPACK_PACKAGE_VERSION_PATCH )
  set ( PACKAGE_VERSION       ${PACKAGE_VERSION}.${CPACK_PACKAGE_VERSION_PATCH} )
endif ( CPACK_PACKAGE_VERSION_PATCH )
set ( PACKAGE_BUGREPORT      bugs@openturns.org )
set( CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION} )

# uninstall target
configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
  IMMEDIATE @ONLY
)

add_custom_target ( uninstall
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

# distcheck target
find_program( TAR_PROGRAM tar ) 
get_filename_component( BUILD_TOOL_NAME ${CMAKE_BUILD_TOOL} NAME )
if ( TAR_PROGRAM AND BUILD_TOOL_NAME MATCHES ".*make" )
  set ( DISTCHECK_BINARY_DIR ${CMAKE_BINARY_DIR}/${CPACK_SOURCE_PACKAGE_FILE_NAME}/_build )
  set ( DISTCHECK_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/${CPACK_SOURCE_PACKAGE_FILE_NAME}/_inst )
  add_custom_target ( distcheck 
    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} "$(MAKE)" package_source
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${DISTCHECK_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${DISTCHECK_INSTALL_PREFIX}
    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ${TAR_PROGRAM} xvfz ${CMAKE_BINARY_DIR}/${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz
    COMMAND ${CMAKE_COMMAND} -E make_directory ${DISTCHECK_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${DISTCHECK_INSTALL_PREFIX}
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} ${CMAKE_COMMAND} .. -DCMAKE_INSTALL_PREFIX=${DISTCHECK_INSTALL_PREFIX}
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)"
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" check
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" install
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" cppinstallcheck
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" pyinstallcheck
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" uninstall
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" clean
  )
endif ()

set ( OPENTURNS_HOME_ENV_VAR OPENTURNS_HOME     )
set ( OPENTURNS_INSTALL_PATH
      ${CMAKE_INSTALL_PREFIX}

=== lib/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

#project ( OpenTURNSLib CXX C Fortran )

# Recurse in subdirectories
add_subdirectory ( include )
add_subdirectory ( src )
add_subdirectory ( etc )

# Build the OpenTURNSConfig.cmake file
get_target_property ( OPENTURNS_LIBRARY_LOC OT LOCATION )
get_filename_component ( OPENTURNS_INSTALL_LIBRARY ${OPENTURNS_LIBRARY_LOC} NAME )

if ( MINGW )
  set ( OPENTURNS_INSTALL_LIBRARY ${OPENTURNS_INSTALL_LIBRARY}.a )
endif ( MINGW )

set ( OPENTURNS_LIBRARY_DIRS            ${LIBRARY_PATH} )
set ( OPENTURNS_LIBRARY                 ${LIBRARY_PATH}/${OPENTURNS_INSTALL_LIBRARY} )
list ( INSERT OPENTURNS_LIBRARIES 0     ${OPENTURNS_LIBRARY} )
set ( OPENTURNS_WRAPPER_LIBRARIES  ${OPENTURNS_LIBRARIES} )
list ( APPEND OPENTURNS_WRAPPER_LIBRARIES -lOTbind )
set ( OPENTURNS_INCLUDE_DIR             ${INCLUDE_PATH})
list ( INSERT OPENTURNS_INCLUDE_DIRS 0  ${OPENTURNS_INCLUDE_DIR} )

set ( OPENTURNS_ROOT_DIR       ${INSTALL_PATH} )
set ( OPENTURNS_VERSION_STRING ${PACKAGE_VERSION} )
set ( OPENTURNS_VERSION_MAJOR  ${CPACK_PACKAGE_VERSION_MAJOR} )
set ( OPENTURNS_VERSION_MINOR  ${CPACK_PACKAGE_VERSION_MINOR} )
set ( OPENTURNS_VERSION_PATCH  ${CPACK_PACKAGE_VERSION_PATCH} )
set ( OPENTURNS_USE_FILE       ${CONFIG_CMAKE_PATH}/UseOpenTURNS.cmake )

if ( LIBXML2_FOUND )
  list ( APPEND OPENTURNS_DEFINITIONS -DHAVE_LIBXML2 )
endif ( LIBXML2_FOUND)
if ( Threads_FOUND OR MINGW )
  list ( APPEND OPENTURNS_DEFINITIONS -DHAVE_PTHREAD_H )
endif ()
list ( APPEND OPENTURNS_DEFINITIONS -DPACKAGE_VERSION=\"${PACKAGE_VERSION}\" )
list ( APPEND OPENTURNS_DEFINITIONS -DPACKAGE_NAME=\"${PACKAGE_NAME}\" )
configure_file ( ${PROJECT_SOURCE_DIR}/lib/OpenTURNSConfig.cmake.in
                 ${PROJECT_BINARY_DIR}/lib/OpenTURNSConfig.cmake
                @ONLY ESCAPE_QUOTES
               )

install ( FILES ${PROJECT_SOURCE_DIR}/lib/UseOpenTURNS.cmake
                ${PROJECT_BINARY_DIR}/lib/OpenTURNSConfig.cmake
          DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
        )

install ( FILES AUTHORS
                COPYING
                COPYING.MuParser
                COPYING.cobyla
                COPYING.dsfmt
                COPYING.lapack
                COPYING.tnc
                COPYING.kissfft
                ChangeLog
                NEWS
                README
                TODO
          DESTINATION ${OPENTURNS_DOC_PATH}
        )

# Recurse in subdirectories : test should be run after src (for target OT to be built)
add_subdirectory ( test )

if ( DOXYGEN_FOUND )

  # generate Doxyfile
  set ( VERSION ${PACKAGE_VERSION} )
  set ( builddir ${CMAKE_CURRENT_BINARY_DIR} )
  set (  top_srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
  configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
                   ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                    @ONLY )
                    
  # generate html doc and compress it
  add_custom_target ( html 
                      COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/doc
                      COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
                      COMMAND tar czf doc-api-${PACKAGE_VERSION}.tar.gz doc
                      COMMAND tar cjf doc-api-${PACKAGE_VERSION}.tar.bz2 doc
                      )                   
                      
endif ( DOXYGEN_FOUND )

install ( FILES ${HEADERFILES}
          DESTINATION ${INCLUDE_PATH}
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        )

=== python/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

#project ( OpenTURNSPython CXX )

include_directories ( ${PYTHON_INCLUDE_DIRS} )

# Recurse in subdirectories
add_subdirectory ( src )
add_subdirectory ( test )

=== utils/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

=== validation/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

add_subdirectory ( src )

=== wrappers/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#
        
install ( FILES WrapperTemplates/wrapper_calling_shell_command/README
                WrapperTemplates/wrapper_calling_shell_command/AUTHORS
                WrapperTemplates/wrapper_calling_shell_command/wrapper.c
                WrapperTemplates/wrapper_calling_shell_command/code_C1.c
                WrapperTemplates/wrapper_calling_shell_command/ChangeLog
                WrapperTemplates/wrapper_calling_shell_command/test.py
                WrapperTemplates/wrapper_calling_shell_command/wcode.xml
                WrapperTemplates/wrapper_calling_shell_command/CMakeLists.txt
                WrapperTemplates/wrapper_calling_shell_command/code_C1.data
          DESTINATION ${OPENTURNS_DATA_PATH}/openturns/WrapperTemplates/wrapper_calling_shell_command
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        )
        
install ( FILES WrapperTemplates/wrapper_calling_shell_command/customize
          DESTINATION ${OPENTURNS_DATA_PATH}/openturns/WrapperTemplates/wrapper_calling_shell_command
          PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
        )

install ( FILES WrapperTemplates/wrapper_linked_with_C_function/README
                WrapperTemplates/wrapper_linked_with_C_function/AUTHORS
                WrapperTemplates/wrapper_linked_with_C_function/wrapper.c
                WrapperTemplates/wrapper_linked_with_C_function/ChangeLog
                WrapperTemplates/wrapper_linked_with_C_function/test.py
                WrapperTemplates/wrapper_linked_with_C_function/wcode.xml
                WrapperTemplates/wrapper_linked_with_C_function/myCFunction.h
                WrapperTemplates/wrapper_linked_with_C_function/CMakeLists.txt
                WrapperTemplates/wrapper_linked_with_C_function/myCFunction.c
          DESTINATION ${OPENTURNS_DATA_PATH}/openturns/WrapperTemplates/wrapper_linked_with_C_function
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        )
        
install ( FILES WrapperTemplates/wrapper_linked_with_C_function/customize
          DESTINATION ${OPENTURNS_DATA_PATH}/openturns/WrapperTemplates/wrapper_linked_with_C_function
          PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
        )

install ( FILES WrapperTemplates/wrapper_linked_with_F77_function/README
                WrapperTemplates/wrapper_linked_with_F77_function/AUTHORS
                WrapperTemplates/wrapper_linked_with_F77_function/wrapper.c
                WrapperTemplates/wrapper_linked_with_F77_function/ChangeLog
                WrapperTemplates/wrapper_linked_with_F77_function/test.py
                WrapperTemplates/wrapper_linked_with_F77_function/wcode.xml
                WrapperTemplates/wrapper_linked_with_F77_function/code.f
                WrapperTemplates/wrapper_linked_with_F77_function/CMakeLists.txt
          DESTINATION ${OPENTURNS_DATA_PATH}/openturns/WrapperTemplates/wrapper_linked_with_F77_function
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        )
        
install ( FILES WrapperTemplates/wrapper_linked_with_F77_function/customize
          DESTINATION ${OPENTURNS_DATA_PATH}/openturns/WrapperTemplates/wrapper_linked_with_F77_function
          PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
        )

=== distro/windows/Makefile ===
#
# Compile and create OpenTURNS installer for windows
#
# Rules dependencies make things done in the right order, however it does not
# detect if OpenTURNS sources has changed. This has to be specified manually:
# - to recompute a rules, remove the corresponding file
#   i.e. some OpenTURNS .cxx have changed:
#     rm ot-compile; make
# - to recompute every rules: make clean; make
#

###############################################################################
# adapt these following lines to your configuration :

# OpenTurns paths
OT_SRC    ?= $(PWD)/../..
OT_BUILD  ?= $(OT_SRC)/mingw_build
OT_PREFIX ?= $(OT_BUILD)/install

# openturns-config not present until installed..
#OT_VERSION ?= $(shell $(OT_PREFIX)/bin/openturns-config --version)
OT_VERSION ?= $(shell cat ../../VERSION)

WINDEPS = $(PWD)/openturns-developers-windeps-$(OT_VERSION)

# compiler prefix
TARGET_MACHINE = i386-mingw32

ifneq ($(shell cmake --version),cmake version 2.8.0)
  SYSTEM_NAME = Windows-GNU-CXX
else
  SYSTEM_NAME = Windows-g++
endif

WINE_PREFIX = $(WINDEPS)/wine
export WINEPREFIX = $(WINE_PREFIX)

MINGW_PREFIX = $(WINDEPS)/mingw-3.4.5
# OpenTURNS dependencies
PYTHON_VERSION = 27
PYTHON_PREFIX = $(WINE_PREFIX)/drive_c/Python$(PYTHON_VERSION)
R_PATH = $(WINE_PREFIX)/drive_c/R/R-2.12.0
PATH := $(R_PATH)/bin:$(PATH)
REGEX_PREFIX = $(MINGW_PREFIX)/opt/regex
LIBXML2_PREFIX = $(MINGW_PREFIX)/opt/libxml2

# launch OpenTURNS checktests before creating the installer (y,n)
CHECK_OT=y

# build and install tests
INSTALL_TESTS_OPT=ON

# parallel compilation (y,n)
DISTCC = n

# verbose (ON/OFF)
VERBOSE = ON

ifeq ($(DISTCC),y)
  # hosts that will be used for library compilation
  JOBS ?= 5
  DISTCC_LIBS_HOSTS ?= "localhost/5"
  # hosts that will be used for python wrapper compilation (needs lots of ram)
  JOBS_PYTHON ?= 2
  DISTCC_WRAPPERS_HOSTS ?= "localhost/2"
  # user define distcc hosts
  include distcc-hosts.mk

  # mingw compiler available on every distcc nodes
  export PATH := $(MINGW_PREFIX)/bin:$(PATH)
  CC=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-gcc
  CPP=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-g++
  #CXX=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-g++
  LD=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-ld
else
  JOBS=$(shell getconf _NPROCESSORS_ONLN)
  JOBS_PYTHON=$(JOBS)
  export PATH := $(MINGW_PREFIX)/bin:$(PATH)
  CC=$(TARGET_MACHINE)-gcc
  CPP=$(TARGET_MACHINE)-g++
  LD=$(TARGET_MACHINE)-ld
endif

DEBUG_OT=n
ifeq ($(DEBUG_OT),n)
  DEBUG_FLAGS=--enable-debug=none CXXFLAGS=-O2 CFLAGS="-O2 -fno-cse-follow-jumps" FFLAGS=-O2
else
  DEBUG_FLAGS=--enable-debug CXXFLAGS=-ggdb CFLAGS=-ggdb FFLAGS=-ggdb
endif

###############################################################################
# should not be modified:

export PYTHON=$(PYTHON_PREFIX)/python.exe
export PYTHON_NOVERSIONCHECK=1
export PYTHON_CPPFLAGS=-I$(PYTHON_PREFIX)/include
export PYTHON_LDFLAGS=-L$(PYTHON_PREFIX)/libs -lpython$(PYTHON_VERSION)
export PYTHON_SITE_PKG=$(PYTHON_PREFIX)/Lib/site-packages
# if PYTHON_EXTRA_LIBS is not set to " ", autotools set PYTHON_EXTRA_LIBS to "None" ...
nullstring :=
export PYTHON_EXTRA_LIBS := $(nullstring) # end of the line

BUILD_MACHINE=$(shell gcc -dumpmachine)


###############################################################################
# rules:

.PHONY: all clean-python clean mrproper


all: ot-installer


ot-check-compiler:
	@echo -n "Check OpenTURNS compilation dependencies: " 
	@ls $(OT_SRC) $(PYTHON_PREFIX) $(PYTHON) $(R_PATH) $(REGEX_PREFIX) \
	  $(LIBXML2_PREFIX) $(PYTHON_SITE_PKG) > /dev/null
	@echo "ok"
	@echo -n "Check mingw-g++ compiler: "
	@$(CPP) -v > /dev/null 2>&1
	@echo "ok"
	touch ot-check-compiler


ot-config: ot-check-compiler
	-mkdir -p $(OT_BUILD)
	cd $(OT_BUILD) && rm -f CMakeCache.txt && cmake .. \
	  -DCMAKE_SYSTEM_NAME=$(SYSTEM_NAME) \
	  -DCMAKE_FIND_ROOT_PATH_MODE_LIBRARY=ONLY \
	  -DCMAKE_FIND_ROOT_PATH_MODE_INCLUDE=ONLY \
	  -DCMAKE_C_COMPILER=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-gcc \
	  -DCMAKE_CXX_COMPILER=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-g++ \
	  -DCMAKE_Fortran_COMPILER=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-g77 \
	  -DCMAKE_VERBOSE_MAKEFILE=$(VERBOSE) \
	  -DFortranCInterface_EXE=$(OT_BUILD)/CMakeFiles/FortranCInterface/FortranCInterface.exe \
	  -DBLAS_blas_LIBRARY=$(MINGW_PREFIX)/opt/blaslapack/blas.dll \
	  -DLAPACK_lapack_LIBRARY=$(MINGW_PREFIX)/opt/blaslapack/lapack.dll \
	  -DLIBDL_INCLUDE_DIR=$(MINGW_PREFIX)/opt/dlfcn/include \
	  -DLIBDL_LIBRARIES=$(MINGW_PREFIX)/opt/dlfcn/lib/libdl.dll.a \
	  -DLIBXML2_INCLUDE_DIR=$(LIBXML2_PREFIX)/include/libxml2 \
	  -DLIBXML2_LIBRARIES=$(LIBXML2_PREFIX)/lib/libxml2.dll.a \
	  -DREGEX_INCLUDE_DIR=$(REGEX_PREFIX)/include \
	  -DREGEX_LIBRARIES=$(REGEX_PREFIX)/lib/libgnurx.dll.a \
	  -DPYTHON_EXECUTABLE=$(PYTHON_PREFIX)/python.exe \
	  -DPYTHON_INCLUDE_DIR=$(PYTHON_PREFIX)/include \
	  -DPYTHON_LIBRARY=$(PYTHON_PREFIX)/libs/libpython$(PYTHON_VERSION).a \
	  -DR_EXECUTABLE=$(R_PATH)/bin/R.exe \
	  -DCMAKE_CXX_FLAGS_RELEASE="-DNDEBUG -O2" \
	  -DCMAKE_C_FLAGS_RELEASE="-DNDEBUG -O2" \
	  -DCMAKE_Fortran_FLAGS_RELEASE="-DNDEBUG -O2" \
	  -DCMAKE_INSTALL_PREFIX=$(OT_PREFIX) \
	  -DINSTALL_TESTS=$(INSTALL_TESTS_OPT)
	touch ot-config

ifeq ($(DISTCC),n)
ot-compile: ot-config
	cd $(OT_BUILD)/lib && make -j$(JOBS)
	cd $(OT_BUILD) && make -j$(JOBS_PYTHON)
	-beep
	touch ot-compile
else
ot-compile: ot-config
	cd $(OT_BUILD)/lib && make -j$(JOBS) CXX="distcc $(CPP)" DISTCC_HOSTS=$(DISTCC_LIBS_HOSTS)
	cd $(OT_BUILD) && make -j$(JOBS_PYTHON) CXX="distcc $(CPP)" DISTCC_HOSTS=$(DISTCC_WRAPPERS_HOSTS)
	-beep
	touch ot-compile
endif


warmup-wine = echo warmup-wine; wine ping -n 5&


ot-check: ot-compile ot-install
ifeq ($(CHECK_OT),y)
	$(call warmup-wine)
	cd $(OT_BUILD) && make check -j$(JOBS)
endif
	touch ot-check


ot-install: ot-compile
	cd $(OT_BUILD) && make install -j$(JOBS) 
	-beep -r 2
	touch ot-install


ot-cppinstallcheck: ot-install
ifeq ($(CHECK_OT),y)
	$(call warmup-wine)
	cd $(OT_BUILD) && PATH=$(PATH):$(PYTHON_PREFIX) make cppinstallcheck -j$(JOBS) VERBOSE=1
	touch ot-cppinstallcheck
endif

ot-pyinstallcheck: ot-install
ifeq ($(CHECK_OT),y)
	$(call warmup-wine)
	cd $(OT_BUILD) && PATH=$(PATH):$(PYTHON_PREFIX) make pyinstallcheck -j$(JOBS) VERBOSE=1
	touch ot-pyinstallcheck
endif

ot-installcheck: ot-cppinstallcheck ot-pyinstallcheck

ot-test: ot-install
	cd $(OT_BUILD) && make tests -j$(JOBS)
ifeq ($(CHECK_OT),y)
	cd $(OT_BUILD) && make test ARGS=-j$(JOBS)
	touch ot-test
endif

ot-test-wrapper-template: ot-install
	rm -rf $(OT_BUILD)/mywrapper
# 	svn export $(OT_SRC)/wrappers/WrapperTemplates/wrapper_linked_with_C_function $(OT_BUILD)/mywrapper
	svn export $(OT_SRC)/wrappers/WrapperTemplates/wrapper_linked_with_F77_function $(OT_BUILD)/mywrapper
# 	svn export $(OT_SRC)/wrappers/WrapperTemplates/wrapper_calling_shell_command $(OT_BUILD)/mywrapper
	cd $(OT_BUILD)/mywrapper && ./customize Pouet && mkdir build && cd build && cmake .. \
	  -DCMAKE_SYSTEM_NAME=$(SYSTEM_NAME) \
	  -DCMAKE_FIND_ROOT_PATH_MODE_LIBRARY=ONLY \
	  -DCMAKE_FIND_ROOT_PATH_MODE_INCLUDE=ONLY \
	  -DCMAKE_C_COMPILER=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-gcc \
	  -DCMAKE_CXX_COMPILER=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-g++ \
	  -DCMAKE_Fortran_COMPILER=$(MINGW_PREFIX)/bin/$(TARGET_MACHINE)-g77 \
	  -DCMAKE_VERBOSE_MAKEFILE=$(VERBOSE) \
	  -DFortranCInterface_EXE=$(OT_BUILD)/CMakeFiles/FortranCInterface/FortranCInterface.exe \
	  -DREGEX_INCLUDE_DIR=$(REGEX_PREFIX)/include \
	  -DREGEX_LIBRARIES=$(REGEX_PREFIX)/lib/libgnurx.dll.a \
	  -DCMAKE_CXX_FLAGS_RELEASE="-DNDEBUG -O2" \
	  -DCMAKE_C_FLAGS_RELEASE="-DNDEBUG -O2" \
	  -DCMAKE_Fortran_FLAGS_RELEASE="-DNDEBUG -O2" \
	  -DOpenTURNS_DIR=$(OT_PREFIX)/lib/cmake/openturns \
	  -DCMAKE_INSTALL_PREFIX=$(OT_BUILD)/mywrapper/build/install && make install
	cd $(OT_BUILD)/mywrapper && cp $(OT_PREFIX)/bin/*.dll .
	cd $(OT_BUILD)/mywrapper && cp $(OT_BUILD)/mywrapper/build/install/bin/* . || :
	cd $(OT_BUILD)/mywrapper && PYTHONPATH=$(OT_PREFIX)/Lib/site-packages OPENTURNS_WRAPPER_PATH=$(OT_BUILD)/mywrapper/build/install/wrappers $(PYTHON_PREFIX)/python.exe test.py

ot-strip: ot-install
ifeq ($(DEBUG_OT),n)
	$(TARGET_MACHINE)-strip -x -g $(OT_PREFIX)/bin/*.dll
	$(TARGET_MACHINE)-strip -g $(OT_PREFIX)/lib/*.a
	$(TARGET_MACHINE)-strip -x -g $(OT_PREFIX)/Lib/site-packages/*/*.pyd
ifeq ($(INSTALL_TESTS_OPT),ON)
	$(TARGET_MACHINE)-strip -x -g $(OT_PREFIX)/share/openturns/examples/*.exe
endif
endif
	touch ot-strip


ot-check-installer: ot-install
	@echo -n "Check OpenTURNS prefix: "
	@ls $(OT_PREFIX) > /dev/null
	@echo "ok"
	@echo -n "Check OpenTURNS windeps directory: "
	@ls $(WINDEPS)/bin/pthreadGC2.dll > /dev/null 2>&1
	@echo "ok"
	@echo -n "Check nsis compiler: "
	@makensis -VERSION > /dev/null 2>&1
	@echo "ok"
	@echo "OpenTURNS installer dependencies seems all right."
	touch ot-check-installer


ot-user-installer: ot-strip ot-check ot-check-installer ot-cppinstallcheck ot-pyinstallcheck ot-check-installer
	makensis -DOPENTURNS_PREFIX=$(OT_PREFIX) -DPRODUCT_VERSION=$(OT_VERSION) -DPYTHON_VERSION=$(PYTHON_VERSION) openturns_script.nsi
	touch ot-user-installer

ot-module-installer: ot-strip ot-check ot-check-installer ot-cppinstallcheck ot-pyinstallcheck ot-check-installer
	makensis -DOPENTURNS_PREFIX=$(OT_PREFIX) -DPRODUCT_VERSION=$(OT_VERSION) -DPYTHON_VERSION=$(PYTHON_VERSION) openturns.nsi
	touch ot-module-installer


ot-dev-installer: ot-strip ot-check ot-check-installer
	makensis -DOPENTURNS_PREFIX=$(OT_PREFIX) -DPRODUCT_VERSION=$(OT_VERSION) -DPYTHON_VERSION=$(PYTHON_VERSION) openturns_developer.nsi
	touch ot-dev-installer


ot-installer: ot-module-installer ot-dev-installer
	#ot-user-installer
	-beep -r 3



clean-python:
	cd $(OT_BUILD)/python && make clean

clean:
	-rm -f ot-*
	-rm -f $(OT_BUILD)/python/src/*_wrap.cxx


mrproper: clean
	-rm -rf $(OT_PREFIX) $(OT_BUILD)
	-rm -f *.exe

=== lib/etc/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

# TODO: These variables are needed for autotools compatibility
set ( r_prog_path ${R_EXECUTABLE} )
set ( temporary_directory ${TEMPDIR} )

configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/openturns.conf.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns.conf
                 @ONLY )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/openturns.conf
          DESTINATION ${OPENTURNS_SYSCONFIG_PATH}/openturns
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        )

=== lib/include/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

include ( FortranCInterface )
FortranCInterface_HEADER ( FortranCInterface.h )

ot_add_current_dir_to_include_dirs ()
ot_add_build_dir_to_include_dirs ( ${CMAKE_CURRENT_BINARY_DIR} )

configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/OTconfig.h.in
                 ${CMAKE_CURRENT_BINARY_DIR}/OTconfig.h
                @ONLY
               )

set ( ot_configure_args )
if ( NOT ot_configure_date )
  execute_process ( COMMAND date -R
                    OUTPUT_VARIABLE ot_configure_date
                    OUTPUT_STRIP_TRAILING_WHITESPACE
                  )
  set ( ot_configure_date "${ot_configure_date}" CACHE STRING "First configure date." )
endif ()
if ( NOT ot_revision )
  execute_process ( COMMAND svnversion
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                    OUTPUT_VARIABLE ot_revision
                    OUTPUT_STRIP_TRAILING_WHITESPACE
                  )
  set ( ot_revision "${ot_revision}" CACHE STRING "Revision number." )
endif ()
mark_as_advanced( ot_configure_date ot_revision )
set ( prefix ${CMAKE_INSTALL_PREFIX} )
set ( PACKAGE openturns )

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/OTconfigure_args.hxx.in
                ${CMAKE_CURRENT_BINARY_DIR}/OTconfigureArgs.hxx
                @ONLY
              )

install ( FILES OTconfig.hxx
                OTdebug.h
                OTmemory.hxx
                OTprivate.hxx
                OTtestcode.hxx
                OTthread.hxx
                OTtypes.hxx
                ${CMAKE_CURRENT_BINARY_DIR}/OTconfig.h
          DESTINATION ${OPENTURNS_INCLUDE_PATH}
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        )

=== lib/src/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

# Register current directory files
ot_add_current_dir_to_include_dirs ()
ot_install_header_file ( OT.hxx )
ot_add_source_file ( openturns_library_ok.c )

foreach ( include_dir ${OPENTURNS_INCLUDE_DIRS} )
  set ( EXTRA_CPPFLAGS "${EXTRA_CPPFLAGS} -I${include_dir}" )
endforeach ()
configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/openturns-config-build.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns-config-build
                 @ONLY
               )
set (WGET wget)
set (CURL curl)
set (prefix "${CMAKE_INSTALL_PREFIX}")
set (exec_prefix "${CMAKE_INSTALL_PREFIX}")
set (libdir "${INSTALL_PATH}/lib${LIB_SUFFIX}")
set (PACKAGE "${CPACK_PACKAGE_NAME}")
configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/openturns-module-build.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns-module-build
                 @ONLY
               )
install ( PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/openturns-config-build
          DESTINATION ${INSTALL_PATH}/bin
          RENAME openturns-config
        )
install ( PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/openturns-module-build
          DESTINATION ${INSTALL_PATH}/bin
          RENAME openturns-module
        )

# Recurse in subdirectories
add_subdirectory ( Base )
add_subdirectory ( Uncertainty )
if ( NOT LAPACK_FOUND AND NOT BLAS_FOUND )
  add_subdirectory ( BlasLapack )
endif ( NOT LAPACK_FOUND AND NOT BLAS_FOUND )

# Build main library
foreach ( built_source ${BUILT_SOURCEFILES} )
  set_source_files_properties ( ${built_source} PROPERTIES GENERATED TRUE )
endforeach ( built_source )
include_directories ( ${INTERNAL_INCLUDE_DIRS} )
link_directories ( ${CMAKE_Fortran_IMPLICIT_LINK_DIRECTORIES} )
add_library ( OTbind SHARED bind.c )
add_library ( OT SHARED ${SOURCEFILES} ${BUILT_SOURCEFILES} )
if ( MINGW )
  set_target_properties ( OT PROPERTIES
                                  LINK_FLAGS "-Wl,--out-implib,libOT.dll.a -Wl,--enable-auto-import" )
  set_target_properties ( OTbind PROPERTIES
                                  LINK_FLAGS "-Wl,--out-implib,libOTbind.dll.a -Wl,--enable-auto-import" )
endif ()
# soversion
if ( NOT DEFINED LIB_VERSION ) 
  set ( LIB_VERSION 0.0.0 )
endif ()
if ( NOT DEFINED LIB_SOVERSION ) 
  set ( LIB_SOVERSION 0 )
endif ()
set_target_properties ( OT OTbind PROPERTIES SOVERSION ${LIB_SOVERSION} )
set_target_properties ( OT OTbind PROPERTIES VERSION ${LIB_VERSION} )

if ( BISON_FOUND )
  add_dependencies ( OT generate_csv_parser )
endif ( BISON_FOUND )
if ( FLEX_FOUND )
  add_dependencies ( OT generate_csv_lexer  )
endif ( FLEX_FOUND )

# CMake makefiles don't link against stdc++ on OSX
if ( APPLE )
  target_link_libraries ( OTbind stdc++ )
endif ( APPLE )

target_link_libraries ( OT ${OPENTURNS_LIBRARIES} )

# Build an empty executable to check link dependencies and completeness
add_executable ( linktest main.cxx )
target_link_libraries ( linktest OT )
set_target_properties ( linktest PROPERTIES
                                 INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${CMAKE_BINARY_DIR}/lib/src" )


# Install rules for library and executable
install ( TARGETS OT OTbind
          RUNTIME DESTINATION bin
          LIBRARY DESTINATION ${LIBRARY_PATH}
          ARCHIVE DESTINATION ${LIBRARY_PATH}
        )

#foreach ( file ${SOURCEFILES} )
#  message ( ">> Will compile ${file}" )
#endforeach ( file )

#foreach ( file ${BUILT_SOURCEFILES} )
#  message ( ">> Will compile built ${file}" )
#endforeach ( file )

#foreach ( file ${HEADERFILES} )
#  message ( ">> Will install ${file}" )
#endforeach ( file )

#get_cmake_property ( VARS VARIABLES )
#foreach ( var ${VARS} )
#  file( APPEND ${CMAKE_CURRENT_BINARY_DIR}/VARS.txt
#        "${var} \"${${var}}\"\n" )
#endforeach ( var )

=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

cmake_minimum_required ( VERSION 2.8 )

#include ( CTest )

set ( NEW_PATH "$ENV{PATH}:${INSTALL_DESTDIR}${EXAMPLE_PATH}" )

set ( ADAPT_CHECK_TESTS_EXPONENT )
set ( REPLACE_EOL " | cat " )
if ( MINGW )
  # replace dos eols
  set ( REPLACE_EOL " | tr -d '\\\\015' " )
  # By default, Mingw-g++ puts 3 digits to real exponent whereas g++ puts 2.
  set ( ADAPT_CHECK_TESTS_EXPONENT "PRINTF_EXPONENT_DIGITS=2" )
endif ( MINGW )

set ( CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${CMAKE_BINARY_DIR}/lib/etc"
                        ${ADAPT_CHECK_TESTS_EXPONENT} 
    )

set ( INSTALLCHECK_ENVIRONMENT "AUTOTEST_PATH=${INSTALL_DESTDIR}${EXAMPLE_PATH}"
                               "OPENTURNS_WRAPPER_PATH=${INSTALL_DESTDIR}${WRAPPER_PATH}"
                               "OPENTURNS_CONFIG_PATH=${INSTALL_DESTDIR}${SYSCONFIG_PATH}/openturns"
                               "OPENTURNS_NUMERICALSAMPLE_PATH=${INSTALL_DESTDIR}${SAMPLE_PATH}"
                               "PATH=${NEW_PATH}"
                               ${ADAPT_CHECK_TESTS_EXPONENT} 
    )

if ( MINGW )
  add_custom_target ( symlink_lib_test_libot
    ${CMAKE_COMMAND} -E create_symlink ${CMAKE_BINARY_DIR}/lib/src/libOT.dll ${CMAKE_CURRENT_BINARY_DIR}/libOT.dll
    COMMAND
    ${CMAKE_COMMAND} -E create_symlink ${CMAKE_BINARY_DIR}/lib/src/libOTbind.dll ${CMAKE_CURRENT_BINARY_DIR}/libOTbind.dll
    DEPENDS OT
    COMMENT "Add a symbolic link to libOT in lib/test."
  )
endif ()
  
set ( EXCLUDE_TEST EXCLUDE_FROM_ALL )
if ( INSTALL_TESTS )
  set ( EXCLUDE_TEST "" )

  macro ( create_check_file FILE_NAME )
    file ( WRITE ${FILE_NAME} "#!/bin/sh\n\n" )
    file ( APPEND ${FILE_NAME} "#set -e\n\n" )
    #file ( APPEND ${FILE_NAME} "#${CHECK_ENVIRONMENT}\n\n" )
    file ( APPEND ${FILE_NAME} "export PRINTF_EXPONENT_DIGITS=2\n" )
    file ( APPEND ${FILE_NAME} "export AUTOTEST_PATH=$PWD\n" )
    file ( APPEND ${FILE_NAME} "export OPENTURNS_CONFIG_PATH=$PWD/..\n" )
    file ( APPEND ${FILE_NAME} "#export OPENTURNS_LOG_SEVERITY=ALL\n" )
    file ( APPEND ${FILE_NAME} "DEBUG_FILE=stdouterr.dbg \n" )
    file ( APPEND ${FILE_NAME} "PATH=$PWD:$PWD/..:$PATH\n" )
    file ( APPEND ${FILE_NAME} "FAILED_TEST=\"\"\n\n" )
    file ( APPEND ${FILE_NAME} "function check_error {\nif [ \"$?\" != \"0\" ]; then\n  FAILED_TEST=\"$FAILED_TEST $1\"\n  echo \"std_err output:\"\n  cat $DEBUG_FILE\n  echo \"Test #$1: $2 failed!\"\n  echo\nfi\n}\n\n" )
  endmacro ( create_check_file FILE_NAME )

  macro ( add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK )
    file ( APPEND ${FILE_NAME} "echo \"Test #${CUR_CHECK}/$NB_CHECK: ${TESTNAME}\"\n" )
    file ( APPEND ${FILE_NAME} "${EXTERNAL_COMMAND}\n" )
    file ( APPEND ${FILE_NAME} "check_error ${CUR_CHECK} ${TESTNAME}\n\n" )
  endmacro ( add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK )

  macro ( finish_check_file FILE_NAME NB_CHECK )
    file ( APPEND ${FILE_NAME} "}\n\n" )
    file ( APPEND ${FILE_NAME} "NB_CHECK=${NB_CHECK}\n" )
    file ( APPEND ${FILE_NAME} "start_tests\necho\n" )
    file ( APPEND ${FILE_NAME} "RC=0\nif [ \"$FAILED_TEST\" = \"\" ]; then\n  echo \"Every check tests are OK.\"\n" )
    file ( APPEND ${FILE_NAME} "else\n  echo \"Tests$FAILED_TEST failed!\"\n  RC=1\nfi\n" )
    file ( APPEND ${FILE_NAME} "exit $RC\n" )
  endmacro ( finish_check_file FILE_NAME )

  # create a standalone sh file that can launch tests
  set ( EXTERNAL_CHECK_FILE "${CMAKE_CURRENT_BINARY_DIR}/start_check_test.sh" )
  create_check_file ( ${EXTERNAL_CHECK_FILE} )
  file ( APPEND ${EXTERNAL_CHECK_FILE} "\nstart_tests() {\n" )
  set ( CUR_CHECK 0 )
  
endif ()

  
# This macro compiles on the fly and run the corresponding pre-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set ( CHECK_TO_BE_RUN )
macro ( ot_check_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.cxx )
  set ( TESTNAME_SRCS ${TESTNAME_SRC} )
  if ( MINGW )
    list ( APPEND TESTNAME_SRCS CRT_fp8.c )
  endif ()
  add_executable ( ${TESTNAME_TGT} ${EXCLUDE_TEST} ${TESTNAME_SRCS} )
  add_dependencies( tests ${TESTNAME_TGT} ) 
  target_link_libraries ( ${TESTNAME_TGT} OT )
  if ( MINGW )
    set_target_properties ( ${TESTNAME_TGT} PROPERTIES
                                            LINK_FLAGS "-Wl,--enable-auto-import" )
    add_dependencies( ${TESTNAME_TGT} symlink_lib_test_libot ) 
  endif ( MINGW )
  set_target_properties ( ${TESTNAME_TGT} PROPERTIES
                                          INSTALL_RPATH "${CMAKE_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}" )
  get_target_property ( TESTNAME_LOC ${TESTNAME_TGT} LOCATION )

  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
    set ( EXTERNAL_COMMAND "./${TESTNAME_TGT} ${_PARAMS} > $DEBUG_FILE 2>&1" )
  else (_IGNOREOUT)
    set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
    get_source_file_property ( OUTFILE_LOC ${TESTNAME_OUT} LOCATION )
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
    set ( EXTERNAL_COMMAND "( ./${TESTNAME_TGT} ${_PARAMS} 2>$DEBUG_FILE | tr -d '\\\\r' > ${TESTNAME_TGT}.out ) && diff -u ${TESTNAME_OUT} ${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set ( COMMAND "${_PRE}${COMMAND}${_POST}" )
    set ( EXTERNAL_COMMAND "${_PRE}${EXTERNAL_COMMAND}${_POST}" )
  endif (_PRE OR _POST)

  add_test ( cppcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  set_tests_properties ( cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}" )
  list ( APPEND CHECK_TO_BE_RUN ${TESTNAME_TGT} )
  install ( FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          )

  if ( INSTALL_TESTS )
    install ( FILES ${TESTNAME_OUT}
              DESTINATION ${EXAMPLE_PATH} 
              PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
            )
    install ( TARGETS ${TESTNAME_TGT}
              DESTINATION ${EXAMPLE_PATH} 
            )

    add_check_file ( ${EXTERNAL_CHECK_FILE} ${TESTNAME_TGT} ${EXTERNAL_COMMAND} ${CUR_CHECK} )
    math( EXPR CUR_CHECK "${CUR_CHECK} + 1" )
  endif ()

endmacro ( ot_check_test )


# create a standalone sh file that can launch tests
if ( INSTALL_TESTS )
  set ( EXTERNAL_INSTALLCHECK_FILE "${CMAKE_CURRENT_BINARY_DIR}/start_installcheck_test.sh" )
  create_check_file ( ${EXTERNAL_INSTALLCHECK_FILE} )
  #file ( APPEND ${EXTERNAL_INSTALLCHECK_FILE} "#${INSTALLCHECK_ENVIRONMENT}\n\n" )
  file ( APPEND ${EXTERNAL_INSTALLCHECK_FILE} "export OPENTURNS_NUMERICALSAMPLE_PATH=$PWD\n" )
  file ( APPEND ${EXTERNAL_INSTALLCHECK_FILE} "export OPENTURNS_WRAPPER_PATH=$PWD/wrappers\n" )
  #file ( APPEND ${EXTERNAL_INSTALLCHECK_FILE} "export abs_srcdir=$PWD\n" )
  file ( APPEND ${EXTERNAL_INSTALLCHECK_FILE} "start_tests() {\n" )
  set ( CUR_INSTALLCHECK 0 )
endif ()


# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set ( INSTALLCHECK_TO_BE_RUN )
macro ( ot_installcheck_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.cxx )
  set ( TESTNAME_SRCS ${TESTNAME_SRC} )
  if ( MINGW )
    list ( APPEND TESTNAME_SRCS CRT_fp8.c )
  endif ()
  add_executable ( ${TESTNAME_TGT} ${EXCLUDE_TEST} ${TESTNAME_SRCS} )
  add_dependencies( tests ${TESTNAME_TGT} ) 
  target_link_libraries ( ${TESTNAME_TGT} OT )
  if ( MINGW )
    set_target_properties ( ${TESTNAME_TGT} PROPERTIES
                                            LINK_FLAGS "-Wl,--enable-auto-import" )
    add_dependencies( ${TESTNAME_TGT} makelinkot ) 
  endif ( MINGW )
  get_target_property ( TESTNAME_LOC ${TESTNAME_TGT} LOCATION )

  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
    set ( EXTERNAL_COMMAND "./${TESTNAME_TGT} ${_PARAMS} > $DEBUG_FILE 2>&1" )
  else (_IGNOREOUT)
    set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
    get_source_file_property ( OUTFILE_LOC ${TESTNAME_OUT} LOCATION )
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
    set ( EXTERNAL_COMMAND "( ./${TESTNAME_TGT} ${_PARAMS} 2>$DEBUG_FILE | tr -d '\\\\r' > ${TESTNAME_TGT}.out ) && diff -u ${TESTNAME_OUT} ${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set ( COMMAND "${_PRE}${COMMAND}${_POST}" )
    #not useful
    #set ( EXTERNAL_COMMAND "${_PRE}${EXTERNAL_COMMAND}${_POST}" )
  endif (_PRE OR _POST)

  add_test ( cppinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  set_tests_properties ( cppinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${INSTALLCHECK_ENVIRONMENT}" )
  list ( APPEND INSTALLCHECK_TO_BE_RUN ${TESTNAME_TGT} )
  install ( FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH}
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          )

  if ( INSTALL_TESTS )
    install ( FILES ${TESTNAME_OUT}

=== python/src/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright (C) 2005-2013 EDF-EADS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#  @author dutka
#  @date   2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010)
#

add_definitions ( ${OPENTURNS_SWIG_DEFINITIONS} )

# generate SWIG runtime header
set ( SWIG_PYTHON_OPTIONS "-python" )
add_custom_command ( OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS ${SWIG_PYTHON_OPTIONS} ${CMAKE_SWIG_FLAGS} ${OPENTURNS_SWIG_DEFINITIONS} -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx
                     COMMENT "Swig header" )
add_custom_target ( generate_swig_runtime DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx )
include_directories ( ${CMAKE_CURRENT_BINARY_DIR} )

include_directories ( ${INTERNAL_INCLUDE_DIRS} )
include_directories ( ${CMAKE_CURRENT_SOURCE_DIR} )

set ( OPENTURNS_PYTHON_MODULES )
macro ( ot_add_python_module MODULENAME SOURCEFILE )
  set_source_files_properties ( ${SOURCEFILE} PROPERTIES CPLUSPLUS ON )
  set_source_files_properties ( ${SOURCEFILE} PROPERTIES SWIG_MODULE_NAME ${MODULENAME} )
  ot_install_swig_file ( ${SOURCEFILE} )
  if ( ${ARGC} GREATER 2 )
    set ( SWIG_MODULE_${MODULENAME}_EXTRA_DEPS ${ARGN} )
  endif ()
    
  set ( swig_other_sources )
  foreach ( it ${ARGN} )
    if ( ${it} MATCHES ".*\\.i$" )
      ot_install_swig_file ( ${it} )
    else ()
      set ( swig_other_sources ${swig_other_sources} "${it}" )
    endif ()
  endforeach ()

  # workaround for a bug in UseSWIG script not supporting multiple modules and parallel compilation
  # http://www.cmake.org/pipermail/cmake/2011-January/042345.html
  if ( CMAKE_VERSION VERSION_LESS 2.8.5 )
    set( swig_extra_generated_files )
  endif ()
  
  swig_add_module ( ${MODULENAME} python ${SOURCEFILE} ${swig_other_sources} )

  add_dependencies ( ${SWIG_MODULE_${MODULENAME}_REAL_NAME} generate_swig_runtime )
  swig_link_libraries ( ${MODULENAME} OT )
  
  if ( LINK_PYTHON_LIBRARY )
    swig_link_libraries ( ${MODULENAME} ${PYTHON_LIBRARIES} )
  endif ()
  
  set_target_properties ( ${SWIG_MODULE_${MODULENAME}_REAL_NAME} PROPERTIES NO_SONAME ON )
  
  if ( MINGW )
    set_target_properties ( ${SWIG_MODULE_${MODULENAME}_REAL_NAME} PROPERTIES
                                                                   LINK_FLAGS "-shared -Wl,--enable-auto-import" )
  endif ()
  list ( APPEND OPENTURNS_PYTHON_MODULES ${MODULENAME} )
endmacro ( ot_add_python_module )

install ( FILES PythonNumericalMathEvaluationImplementation.hxx
                PythonRandomVectorImplementation.hxx
                PythonDistributionImplementation.hxx
                PythonWrappingFunctions.hxx
          DESTINATION ${OPENTURNS_INCLUDE_PATH}
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        )

if ( LIBXML2_FOUND )
  list ( APPEND SWIG_MODULE_common_EXTRA_FLAGS -DHAVE_LIBXML2=1 )
endif ()
ot_add_python_module( common common_module.i
                      OTtypes.i
                      OTexceptions.i
                      Memory.i
                      Object.i
                      PersistentObject.i
                      Study.i
                      StorageManager.i
                      XMLStorageManager.i
                      Log.i
                      MPI.i
                      TTY.i
                      Path.i
                      Catalog.i
                      ResourceMap.i
                      ComparisonOperatorImplementation.i
                      ComparisonOperator.i
                      Equal.i
                      Greater.i
                      GreaterOrEqual.i
                      Less.i
                      LessOrEqual.i
                      Cache.i
                      Threadable.i
                      PlatformInfo.i
                      SharedPointer.i
                      Pointer.i
                      InterfaceObject.i
                      TypedInterfaceObject.i
                      TypedCollectionInterfaceObject.i
                      BaseCommonTemplateDefs.i
                      PythonWrappingFunctions.hxx
                    )
                     
ot_add_python_module( wrapper wrapper_module.i
                      Collection.i
                      WrapperData.i
                      WrapperFile.i
                      BaseWrapperTemplateDefs.i
                      PythonWrappingFunctions.hxx
                    )
                    
ot_add_python_module( typ typ_module.i
                      PersistentCollection.i
                      DescriptionImplementation.i
                      Description.i
                      NumericalPoint.i
                      NumericalPointWithDescription.i
                      Indices.i
                      MatrixImplementation.i
                      Matrix.i
                      SquareMatrix.i
                      SymmetricMatrix.i
                      TensorImplementation.i
                      Tensor.i
                      SymmetricTensor.i
                      BaseTypTemplateDefs.i
                      ComplexMatrixImplementation.i
                      ComplexMatrix.i
                      HermitianMatrix.i
                      SquareComplexMatrix.i
                      TriangularComplexMatrix.i
                      CovarianceMatrix.i
                      CorrelationMatrix.i
                      IdentityMatrix.i
                      NumericalSample.i
                      HistoryStrategyImplementation.i
                      HistoryStrategy.i
                      PythonWrappingFunctions.hxx
                    )
                    
ot_add_python_module( statistics statistics_module.i
                      Compact.i
                      Full.i
                      Last.i
                      Null.i
                      ConfidenceInterval.i
                      LinearModel.i
                      LinearModelFactory.i
                      TestResult.i
                      ProcessSample.i
                      RandomGenerator.i
                      CorrelationAnalysis.i
                      SensitivityAnalysis.i
                      LowDiscrepancySequenceImplementation.i
                      LowDiscrepancySequence.i
                      SobolSequence.i
                      FaureSequence.i
                      HaltonSequence.i
                      HaselgroveSequence.i
                      ReverseHaltonSequence.i
                      TimeSeries.i
                      BaseStatisticsTemplateDefs.i
                      SecondOrderModelImplementation.i
                      SecondOrderModel.i
                      ExponentialCauchy.i
                      FilteringWindowsImplementation.i
                      FilteringWindows.i
                      Hamming.i
                      Hanning.i
                      SpectralModelImplementation.i
                      SpectralModel.i
                      CovarianceModelImplementation.i
                      CovarianceModel.i
                      StationaryCovarianceModel.i
                      SpectralModelFactoryImplementation.i
                      SpectralModelFactory.i
                      UserDefinedSpectralModel.i
                      WelchFactory.i
                      ExponentialModel.i
                      CauchyModel.i
                      CovarianceModelFactoryImplementation.i
                      CovarianceModelFactory.i
                      UserDefinedCovarianceModel.i
                      NonStationaryCovarianceModelFactory.i
                      UserDefinedStationaryCovarianceModel.i
                      StationaryCovarianceModelFactory.i
                      PythonWrappingFunctions.hxx
                    )
                    
ot_add_python_module( geom geom_module.i
                      DomainImplementation.i
                      Domain.i
                      Interval.i
                      Mesh.i
                      BaseGeomTemplateDefs.i
                     )
                     
ot_add_python_module( graph graph_module.i
                      DrawableImplementation.i
                      Drawable.i
                      GraphImplementation.i
                      Graph.i
                      BarPlot.i
                      Cloud.i
                      Contour.i
                      Curve.i
                      Pairs.i
                      Pie.i
                      Polygon.i
                      Staircase.i
                      BaseGraphTemplateDefs.i
                      PythonWrappingFunctions.hxx
                    )
                    
ot_add_python_module( func func_module.i
                      SpecFunc.i
                      NumericalMathEvaluationImplementation.i
                      NumericalMathGradientImplementation.i
                      NumericalMathHessianImplementation.i
                      NoNumericalMathEvaluationImplementation.i
                      NoNumericalMathGradientImplementation.i
                      NoNumericalMathHessianImplementation.i
                      LinearNumericalMathEvaluationImplementation.i
                      LinearNumericalMathGradientImplementation.i
                      QuadraticNumericalMathEvaluationImplementation.i
                      ConstantNumericalMathGradientImplementation.i
                      ConstantNumericalMathHessianImplementation.i
                      ComputedNumericalMathEvaluationImplementation.i
                      ComputedNumericalMathGradientImplementation.i
                      ComputedNumericalMathHessianImplementation.i
                      ComposedNumericalMathEvaluationImplementation.i
                      ComposedNumericalMathGradientImplementation.i
                      ComposedNumericalMathHessianImplementation.i
                      DualLinearCombinationEvaluationImplementation.i
                      DualLinearCombinationGradientImplementation.i
                      DualLinearCombinationHessianImplementation.i
                      LinearCombinationEvaluationImplementation.i
                      LinearCombinationGradientImplementation.i
                      LinearCombinationHessianImplementation.i
                      ProductNumericalMathEvaluationImplementation.i
                      ProductNumericalMathGradientImplementation.i
                      ProductNumericalMathHessianImplementation.i
                      NumericalMathFunctionImplementation.i
                      ComposedNumericalMathFunction.i
                      ProductNumericalMathFunction.i
                      NumericalMathFunction.i
                      BaseFuncCollection.i
                      DynamicalFunctionImplementation.i
                      DynamicalFunction.i
                      SpatialFunction.i
                      TemporalFunction.i
                      LinearNumericalMathFunction.i
                      UniVariatePolynomialImplementation.i
                      UniVariatePolynomial.i
                      AggregatedNumericalMathEvaluationImplementation.i
                      AnalyticalNumericalMathEvaluationImplementation.i
                      AnalyticalNumericalMathGradientImplementation.i
                      AnalyticalNumericalMathHessianImplementation.i

=== debian/changelog ===
openturns (1.2-2) unstable; urgency=low

  * Upload into unstable
  * debian/rules: also set CMAKE_EXE_LINKER_FLAGS with dpkg-buildflags's
    output.

 -- Denis Barbier <barbier@debian.org>  Fri, 09 Aug 2013 22:22:59 +0200

openturns (1.2-1) experimental; urgency=low

  [Julien Schueller]
  * New upstream version 1.2
  * Drop patches merged upstream:
      fix-bigendian.patch
      remove-soname-python-module.patches
  * Rename debian/patches/tests-disable-distributed_python_wrapper.patch
    into debian/patches/tests-disable-coupling_tools.patch

 -- Denis Barbier <barbier@debian.org>  Thu, 25 Jul 2013 20:06:52 +0200

openturns (1.2~rc1-2) experimental; urgency=low

  [ Denis Barbier ]
  * debian/rules: Fix FTBFS on *-i386, copied from 1.1-8.

  [ Julien Schueller ]
  * debian/patches/fix-bigendian.patch: Patch rewritten to use
    CMake detection of endianness.

 -- Denis Barbier <barbier@debian.org>  Mon, 15 Jul 2013 20:47:24 +0200

openturns (1.2~rc1-1) experimental; urgency=low

  [Julien Schueller]
  * New upstream version 1.2rc1
  * Bump soname to 0.3
  * Drop patches merged upstream:
     add-missing-header-file.patch debian-soname.patch
     fix-swig-warning.patch ftbfs-bison-2.7.patch
  * Launch tests in parallel

 -- Denis Barbier <barbier@debian.org>  Fri, 28 Jun 2013 01:51:22 +0200

openturns (1.1-9) unstable; urgency=low

  [ Julien Schueller ]
  * debian/control: All libraries listed in OPENTURNS_LIBRARIES
    variable into OpenTURNSConfig.cmake must be installed in order
    to link against OT.  Let libopenturns-dev depend on
     libxml2-dev, liblapack-dev, libblas-dev, libtbb-dev [i386 amd64 ia64]

  [ Denis Barbier ]
  * debian/control: Replace Architecture: any by an hardcoded list
    of supported architectures.  Openturns requires more than 1GB RAM,
    this caused a lot of trouble on mips* architectures.

 -- Denis Barbier <barbier@debian.org>  Thu, 18 Jul 2013 19:10:04 +0200

openturns (1.1-8) unstable; urgency=low

  * debian/rules: Fix building source package on *-i386, there was
    trouble with debian/patches/modify-tests-O0-i386.patch.

 -- Denis Barbier <barbier@debian.org>  Fri, 05 Jul 2013 18:06:37 +0200

openturns (1.1-7) unstable; urgency=low

  * debian/patches/modify-tests-O0-i386.patch: On *-i386 architectures,
    algocobyla.c is compiled with -O0 flag since 1.1-6; output of
    two tests is modified.  Closes: #714915

 -- Denis Barbier <barbier@debian.org>  Thu, 04 Jul 2013 22:36:45 +0200

openturns (1.1-6) unstable; urgency=low

  * debian/rules: The previous change fixed C++ tests on kfreebsd-i386,
    but pyinstallcheck_Cobyla_nonlinear hangs.  There is another hang
    on i386.  The -fno-guess-branch-probability flag fixes the failure
    on kfreebsd-i386, but compile instead algocobyla.c with -O0 flag
    on *-i386 architectures to be safe.  Closes: #714411

 -- Denis Barbier <barbier@debian.org>  Tue, 02 Jul 2013 20:08:27 +0200

openturns (1.1-5) unstable; urgency=low

  * debian/rules: algocobyla.c is again miscompiled with gcc 4.8.1
    on kfreebsd-i386 and hurd-i386, cppcheck_TrapezoidalFactory_std
    and cppcheck_WhittleFactory_std hang; compile with -fno-caller-saves
    to avoid these problems.  Closes: #714411

 -- Denis Barbier <barbier@debian.org>  Sat, 29 Jun 2013 23:50:27 +0200

openturns (1.1-4) unstable; urgency=low

  * Upload into unstable
  * Bump Standards-Version to 3.9.4, no changes are needed.

 -- Denis Barbier <barbier@debian.org>  Thu, 27 Jun 2013 22:58:17 +0200

openturns (1.1-3) experimental; urgency=low

  * debian/rules: Adjust Python detection so that it works with
    multiarch and non-multiarch Python.
  * debian/patches/ftbfs-bison-2.7.patch: New patch, to fix build
    failures with newer Bison.
  * debian/patches/tests-disable-distributed_python_wrapper.patch:
    New patch, to disable distributed python wrapper tests, these
    tests sometimes fail in strange ways.
  * debian/patches/fix-swig-warning.patch: New patch, taken from
    upstream. Several tests are missing because of a behavior change
    in swig 2.0.9, fix .i files.

 -- Denis Barbier <barbier@debian.org>  Thu, 30 May 2013 23:51:47 +0200

openturns (1.1-2) experimental; urgency=low

  [ Julien Schueller ]
  * debian/rules: Install CMake files into /usr/lib/cmake/openturns
  * debian/patches/add-missing-header-file.patch: New patch, to
    install missing header file WrapperCommon_extern.h

  [ Denis Barbier ]
  * debian/patches/tests-disable-timing.patch: New patch, to disable
    test timings.  They are useless, and prevent openturns from
    building on Hurd.
  * debian/patches/remove-soname-python-module.patch: New patch, to
    remove SONAME from Python modules, this confuses dpkg-shlibdeps.
  * debian/control: Let openturns-examples explicitly depend on python.
  * debian/rules: Pass LDFLAGS when building shared libraries.
  * openturns-examples: Remove duplicates from /usr/lib/openturns/examples/.

 -- Denis Barbier <barbier@debian.org>  Tue, 05 Feb 2013 01:23:41 +0100

openturns (1.1-1) experimental; urgency=low

  [ Denis Barbier ]
  * New upstream version
  * License has been updated to LGPL-3+
  * Drop patches merged upstream:
      fix-dtd-search-path.patch install_cmake_files.patch
      kfreebsd-fix-t_WrapperFile_generic.patch
  * Let libopenturns-dev ship CMake files.
  * debian/watch: Check for tar.bz2 instead of tar.gz
  * debian/copyright: Convert to machine-readable format
    and add missing stanzas.

  [ Julien Schueller ]
  * debian/rules: Drop chmod calls, they are useless.
  * debian/rules: Removed useless clean override.
  * debian/control: Fix URL in Homepage field.

 -- Denis Barbier <barbier@debian.org>  Sun, 13 Jan 2013 09:46:40 +0100

openturns (1.1~rc1-3) experimental; urgency=low

  * debian/patches/kfreebsd-fix-t_WrapperFile_generic.patch: New
    patch to fix t_WrapperFile_generic.py failure on kfreebsd.

 -- Denis Barbier <barbier@debian.org>  Sun, 09 Dec 2012 21:39:44 +0100



=== debian/control ===
Source: openturns
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Denis Barbier <barbier@debian.org>
Build-Depends: debhelper (>= 8), quilt, gfortran, bison, flex, libxml2-dev, liblapack-dev, libblas-dev, libtbb-dev [i386 amd64 ia64], r-base-core, python-dev, swig, cmake, bc
Standards-Version: 3.9.4
Homepage: http://www.openturns.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/openturns.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/openturns.git
X-Python-Version: current

Package: libopenturns0.3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: python-openturns, r-base-core, ghostscript, r-other-rot (= ${binary:Version})
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: dynamic libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * define the outputs of interest and decision criteria;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the dynamic libraries.
 .
 The library implements almost all the treatments of uncertainty that
 OpenTURNS can provide. It is designed to be linked against any user
 specific application, or with either the textual front-end (see
 python-openturns package).
 .
 The main function of that library is giving to specific applications
 all the functionalities needed to treat uncertainties in
 studies. Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.

Package: libopenturns-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libopenturns0.3 (= ${binary:Version}),
  libxml2-dev, liblapack-dev, libblas-dev, libtbb-dev [i386 amd64 ia64]
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: headers and development libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the OpenTURNS headers should be used if one
 wants to link its application against the library.

Package: libopenturns-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libopenturns-dev
Description: debug symbols for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the debug symbols of the OpenTurns libraries to
 help with debugging either your applications or OpenTURNS

Package: python-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenturns0.3 (= ${binary:Version}), ${python:Depends}
Provides: ${python:Provides}
Suggests: python-matplotlib, python-scipy
Description: Python front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides a textual user interface that gives access to
 all the functionalities provided by the OpenTURNS library.

Package: python-openturns-dev
Section: python
Architecture: any
Depends: ${misc:Depends}, libopenturns-dev, python-openturns (= ${binary:Version}), python-dev
Replaces: libopenturns-dev
Breaks: libopenturns-dev (<< 1.0)
Description: Python front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides development files for python modules.

Package: r-other-rot
Section: gnu-r
Architecture: any
Depends: ${misc:Depends}, r-base-core
Replaces: python-openturns
Breaks: python-openturns (<< 1.0)
Description: GNU R package of few tools needed by OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides R files needed by some OpenTURNS objects.

Package: openturns-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python, python-openturns (= ${binary:Version}), libopenturns-dev
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: examples of OpenTURNS functionalities
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides examples which are written either in C++ or in
 Python.
 .
 They are primarly used as validation tests for the whole
 platform but they can also be seen as tutorials for
 beginners.

Package: openturns-validation
Section: science
Architecture: all
Depends: ${misc:Depends}
Description: validation files for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package includes many maple input files that validates the
 results and the algorithms of OpenTURNS in a mathematical sense.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif
$(info DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	test_makeflags = -j$(NUMJOBS)
endif

cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
cflags := $(shell dpkg-buildflags --get CFLAGS) $(cppflags)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS) $(cppflags)
fflags := $(shell dpkg-buildflags --get FFLAGS)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)
ldflags += -Wl,--as-needed

ifeq ($(shell dpkg --print-architecture),armel)
    cflags := $(subst -O2,-O1,$(cflags))
    cxxflags := $(subst -O2,-O1,$(cxxflags))
    fflags := $(subst -O2,-O1,$(fflags))
endif
ifeq ($(shell dpkg --print-architecture),armhf)
    cflags := $(subst -O2,-O1,$(cflags))
    cxxflags := $(subst -O2,-O1,$(cxxflags))
    fflags := $(subst -O2,-O1,$(fflags))
endif
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 kfreebsd-i386 hurd-i386))
    cflags += -O0
endif
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 amd64 ia64))
    with_tbb := -DUSE_TBB:BOOL=ON
else
    with_tbb := -DUSE_TBB:BOOL=OFF
endif

# Explicitly set builddir directory
builddir := obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

debRlib := $(CURDIR)/debian/tmp/usr/lib/R/site-library
export R_LIBS=$(debRlib)
PYVER = $(shell pyversions -dv)

%:
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), mips mipsel))
	$(error This package requires more than 1GB RAM; do not build on mips/mipsel)
endif
	dh $@ --buildsystem=cmake --builddirectory=$(builddir) --with python2 --with quilt --parallel

debian/tmp/usr/lib/R/site-library/rot:
	-mkdir -p $(debRlib)
	R CMD INSTALL --library=$(debRlib) utils/rot_1.4.5.tar.gz

ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 kfreebsd-i386 hurd-i386))
override_dh_quilt_patch:
	dh_quilt_patch
	test -e debian/patches/modify-tests-O0-i386.applied || patch -p1 < debian/patches/modify-tests-O0-i386.patch
	touch debian/patches/modify-tests-O0-i386.applied

override_dh_quilt_unpatch:
	test ! -e debian/patches/modify-tests-O0-i386.applied || patch -R -p1 < debian/patches/modify-tests-O0-i386.patch
	-rm -f debian/patches/modify-tests-O0-i386.applied
	dh_quilt_unpatch
endif

override_dh_auto_configure: debian/tmp/usr/lib/R/site-library/rot
	dh_auto_configure -- \
            $(with_tbb) \
            -DCMAKE_CXX_COMPILER:FILEPATH=/usr/bin/g++ \
            -DCMAKE_Fortran_COMPILER:FILEPATH=/usr/bin/gfortran \
            -DCMAKE_C_COMPILER:FILEPATH=/usr/bin/gcc \
            -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
            -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING='$(cflags)' \
            -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING='$(cxxflags)' \
            -DCMAKE_Fortran_FLAGS_RELWITHDEBINFO:STRING='$(fflags)' \
            -DCMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DLIB_SOVERSION=0.3 \
            -DLIB_VERSION=0.3.0 \
            -DOPENTURNS_SYSCONFIG_PATH:PATH=/etc/openturns-1.2 \
            -DOPENTURNS_WRAPPER_PATH:PATH=lib/openturns-1.2/wrappers \
            -DSYSTEM_INSTALL:BOOL=ON \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp \
            -DLINK_PYTHON_LIBRARY:BOOL=OFF \
            -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python \
            -DPYTHON_INCLUDE_DIR:PATH=$$(python$(PYVER)-config --includes | sed -e 's/ .*//' -e 's/^-I//') \
            -DPYTHON_INCLUDE_DIR2:PATH=$$(python$(PYVER)-config --includes | sed -e 's/ .*//' -e 's/^-I//') \
            -DPYTHON_LIBRARY:PATH=$$(python$(PYVER)-config --ldflags | sed -e 's/ .*//' -e 's/^-L//')/libpython$(PYVER).so

override_dh_auto_install: debian/tmp/usr/lib/R/site-library/rot
	dh_auto_install
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# CTestTestfile.cmake sets LD_LIBRARY_PATH to find libraries in debian/tmp.
	# But it overrides current value, which breaks when run by fakeroot.
	[ -z "$$LD_LIBRARY_PATH" ] || sed -i -e "s#;LD_LIBRARY_PATH=[^;]*#&:$$LD_LIBRARY_PATH#" $(builddir)/python/test/CTestTestfile.cmake
	CTEST_OUTPUT_ON_FAILURE=1 \
	  R_LIBS_SITE=$(CURDIR)/debian/tmp/usr/lib/R/site-library \
	  $(MAKE) $(test_makeflags) -C $(builddir) test ARGS="$(test_makeflags) -R pyinstallcheck"
endif

override_dh_makeshlibs:
	dh_makeshlibs -Xpyshared

override_dh_strip:
	dh_strip -plibopenturns0.3 --dbg-package=libopenturns-dbg
	dh_strip

override_dh_python2:
	dh_python2 --no-guessing-versions

override_dh_compress:
	dh_compress -X.pdf -X.svn -X.py

override_dh_auto_test:
	# 'make test' does not build binary tests
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) $(test_makeflags) -C $(builddir) tests
	CTEST_OUTPUT_ON_FAILURE=1 $(MAKE) -C $(builddir) test ARGS="$(test_makeflags) -R cppcheck"
endif

get-orig-source:
	uscan --force-download --verbose
	mv ../openturn*.tar.[gzbz2]* ../tarballs
